import { Ref } from 'vue';
import { FetchState, Options, PluginReturn, Service } from './types';
export default class Fetch<TData, TParams extends any[] = any> {
    serviceRef: Ref<Service<TData, TParams>>;
    options: Options<TData, TParams>;
    setUpdataData: (s: any, key?: keyof FetchState<TData, TParams>) => void;
    initState: Partial<FetchState<TData, TParams>>;
    pluginImpls: PluginReturn<TData, TParams>[] | undefined;
    count: number;
    state: FetchState<TData, TParams>;
    constructor(serviceRef: Ref<Service<TData, TParams>>, options: Options<TData, TParams>, setUpdataData: (s: any, key?: keyof FetchState<TData, TParams>) => void, initState?: Partial<FetchState<TData, TParams>>);
    setState(s?: Partial<FetchState<TData, TParams>>): void;
    setData(data: any, key?: keyof FetchState<TData, TParams> | (keyof FetchState<TData, TParams>)[]): void;
    runPluginHandler(event: keyof PluginReturn<TData, TParams>, ...rest: any[]): any;
    runAsync(...params: TParams): Promise<TData>;
    run(...params: TParams): void;
    cancel(): void;
    refresh(): void;
    refreshAsync(): Promise<TData>;
    mutate(data?: TData | ((oldData?: TData) => TData | undefined)): void;
}
