import { Ref } from "vue";
import type { ParseOptions, StringifyOptions } from "query-string";
declare type UrlState = Record<string, any>;
export interface Options {
    navigateMode?: "push" | "replace";
    parseOptions?: ParseOptions;
    stringifyOptions?: StringifyOptions;
}
declare const useUrlState: <S extends UrlState = UrlState>(initialState?: S | (() => S) | undefined, options?: Options | undefined) => {
    state: Ref<any>;
    setState: (s: Partial<{ [key in keyof S]: any; }> | ((prev: any) => Partial<{ [key in keyof S]: any; }>)) => void;
};
export default useUrlState;
